#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityFishingCeleStage.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityFishingCeleStage> M_ActivityFishingCeleStage::msSingleton(nullptr);

int M_ActivityFishingCeleStage::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleStageData* M_ActivityFishingCeleStage::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityFishingCeleStageData>& M_ActivityFishingCeleStage::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleStage::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityFishingCeleStage::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleStageData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ActiveId = element->Attribute("ActiveId");
			std::vector<std::string> vecActiveId;
			boost::split(vecActiveId, ActiveId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiveId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiveId[i].c_str(), &temp))
				{
					data.mActiveId.push_back(temp);
				}
			}
		}
		{
			const char* ActiveCount = element->Attribute("ActiveCount");
			std::vector<std::string> vecActiveCount;
			boost::split(vecActiveCount, ActiveCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiveCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiveCount[i].c_str(), &temp))
				{
					data.mActiveCount.push_back(temp);
				}
			}
		}
		data.mSubAllowCount = element->IntAttribute("SubAllowCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityFishingCeleStage::Load()
{
	Load("../Config/M_ActivityFishingCeleStage.xml");
}

M_ActivityFishingCeleStage* M_ActivityFishingCeleStage::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleStage());
	}
	return msSingleton.get();
}
